/*****************************************************************************
**
** parse_cl.c
**
** Tue May  5 12:39:00 1998
** mike@cathmike (Mike Borella)
**
** Main command line parsing routines
**
** Automatically created by genparse v0.2.2
**
** See http://www.xnet.com/~cathmike/MSB/Software/ for details
**
*****************************************************************************/


#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include "parse_cl.h"

/*----------------------------------------------------------------------------
 *
 * usage()
 *
 *----------------------------------------------------------------------------
 */

void usage(char *exc)
{
  printf("usage: %s [ -t ]\n", exc);
  printf("  [ -t ] ");
  printf("[ --tosbyte ] ");
  printf("TOS byte value");
  printf("\n");

  exit(1);
}

/*----------------------------------------------------------------------------
 *
 * free_args()
 *
 *----------------------------------------------------------------------------
 */

void free_args(struct arg_t *my_arg)
{
  free(my_arg);
}

/*----------------------------------------------------------------------------
 *
 * parse_cl()
 *
 *----------------------------------------------------------------------------
 */

struct arg_t *parse_cl(int argc, char *argv[])
{
  extern char *optarg;
  extern int optind;
  int option_index = 0;
  char c;
  struct arg_t *my_arg;
  int errflg = 0;

  static struct option long_options[] =
  {
    {"tosbyte", 1, 0, 't'},
    {0, 0, 0, 0}
  };


  my_arg = (struct arg_t *) malloc (sizeof(struct arg_t));

  my_arg->t = 255;

  while ((c = getopt_long(argc, argv, "t:", long_options, &option_index)) != EOF)
    {
      switch(c)
        {
        case 't':
          my_arg->t = atoi(optarg);
          if (my_arg->t < 1)
            {
              fprintf(stderr, "parameter range error: t must be >= 1\n");
              errflg ++;
            }
          if (my_arg->t > 255)
            {
              fprintf(stderr, "parameter range error: t must be <= 255\n");
              errflg ++;
            }
          break;

        default:
          usage(argv[0]);

        }
    } /* while */

    if (errflg)
      usage(argv[0]);

    if (!(my_arg))
      usage(argv[0]);

  my_arg->optind = optind;
  return my_arg;
}
